<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class LogtransfAgendFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function insertLogTrasnfer($param) {
        $sql = "INSERT INTO FCM_LOGTRANSFAGEND (NRLOGTRANSFAGEND, NRCHECKLISTAGEND, NRFUNCIONARIOORIGEM, DTHORAAGENDORIG, NRFUNCIONARIODESTINO,
                            DTHORAAGENDDESTINO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRFUNCREALIZATRANSF)
                    VALUES (:NRLOGTRANSFAGEND, :NRCHECKLISTAGEND, :NRFUNCIONARIOORIGEM,TO_DATE(:DTHORAAGENDORIG,'YYYY/MM/DD HH24:MI'),
                    :NRFUNCIONARIODESTINO,TO_DATE(:DTHORAAGENDDESTINO,'YYYY/MM/DD HH24:MI'), 20, 'S', SYSDATE, SYSDATE, :NRFUNCREALIZATRANSF)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }

    public function getHistorico(){
        $sql = "SELECT FCM_LOGTRANSFGERCHK.NRGERENCIAMENTOCHK as id, ('Vistoria - ' || FCM_GERENCIAMENTOCHK.NMGERENCIAMENTOCHK) AS NOME, TO_CHAR(FCM_GERENCIAMENTOCHK.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') as DTHORAAGEND, ORIGEM.NMFUNCIONARIO AS FUNCORIGEM,
                        DESTINO.NMFUNCIONARIO AS FUNCDESTINO, TO_CHAR(FCM_LOGTRANSFGERCHK.DTINCLUSAO, 'DD/MM/YYYY HH24:MI') as DTINCLUSAO, RESPDESTINOONSAVEL.NMFUNCIONARIO AS RESPONSAVEL
                  FROM FCM_LOGTRANSFGERCHK
             LEFT JOIN FCM_GERENCIAMENTOCHK
                    ON FCM_LOGTRANSFGERCHK.NRGERENCIAMENTOCHK = FCM_GERENCIAMENTOCHK.NRGERENCIAMENTOCHK
             LEFT JOIN FCM_FUNCIONARIO ORIGEM
                    ON FCM_LOGTRANSFGERCHK.NRFUNCIONARIOORIGEM = ORIGEM.NRFUNCIONARIO
             LEFT JOIN FCM_FUNCIONARIO DESTINO
                    ON FCM_LOGTRANSFGERCHK.NRFUNCIONARIODESTINO = DESTINO.NRFUNCIONARIO
             LEFT JOIN FCM_FUNCIONARIO RESPDESTINOONSAVEL
                    ON FCM_LOGTRANSFGERCHK.NRFUNCREALIZATRANSF = RESPDESTINOONSAVEL.NRFUNCIONARIO
                
                UNION
                
                SELECT FCM_LOGTRANSFAGEND.NRCHECKLISTAGEND as id, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND AS NOME, TO_CHAR(FCM_CHECKLISTAGEND.DTHORAAGEND, 'DD/MM/YYYY HH24:MI') as DTHORAAGEND, ORIGEM.NMFUNCIONARIO AS FUNCORIGEM,
                        DESTINO.NMFUNCIONARIO AS FUNCDESTINO, TO_CHAR(FCM_LOGTRANSFAGEND.DTINCLUSAO, 'DD/MM/YYYY HH24:MI') as DTINCLUSAO, RESPDESTINOONSAVEL.NMFUNCIONARIO AS RESPONSAVEL
                  FROM FCM_LOGTRANSFAGEND
             LEFT JOIN FCM_CHECKLISTAGEND
                    ON FCM_LOGTRANSFAGEND.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
             LEFT JOIN FCM_FUNCIONARIO ORIGEM
                    ON FCM_LOGTRANSFAGEND.NRFUNCIONARIOORIGEM = ORIGEM.NRFUNCIONARIO
             LEFT JOIN FCM_FUNCIONARIO DESTINO
                    ON FCM_LOGTRANSFAGEND.NRFUNCIONARIODESTINO = DESTINO.NRFUNCIONARIO
             LEFT JOIN FCM_FUNCIONARIO RESPDESTINOONSAVEL
                    ON FCM_LOGTRANSFAGEND.NRFUNCREALIZATRANSF = RESPDESTINOONSAVEL.NRFUNCIONARIO
              ORDER BY DTINCLUSAO DESC";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
}

?>