<?php
namespace FM\Service;

use FM\Factory\UsuariosFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class UsuariosService {

    protected $UsuariosFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (UsuariosFactory $UsuariosFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager) {
        $this->UsuariosFactory              = $UsuariosFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getUsersService($params){
        $validParam = '';

        if($params['userSearch'] != '' && $params['userSearch'] != null ) {
            $validParam = "AND UPPER(NMFUNCIONARIO) LIKE UPPER('%".$params['userSearch']."%')";
        }
        $operadores = $this->UsuariosFactory->getUsersFactory($validParam);
        return $operadores;
    }

     public function usersListService(){
        $operadores = $this->UsuariosFactory->usersListFactory();
        return $operadores;
    }

    public function createUserService($nmfuncionario, $nrperfilacesso, $nrcpffuncionario, $nrrgfuncionario, $dsemailfuncionario, $nrtelfuncionario, $nrsetor, $cdoperador) {

    $this->connection->beginTransaction();
    try {

        $nrrgfuncionario = str_replace('.', '', $nrrgfuncionario);
        $nrcpffuncionario = str_replace('.', '', $nrcpffuncionario);
        $nrcpffuncionario = str_replace('-', '', $nrcpffuncionario);
        $nrtelfuncionario = str_replace('(', '', $nrtelfuncionario);
        $nrtelfuncionario = str_replace(')', '', $nrtelfuncionario);
        $nrtelfuncionario = str_replace('-', '', $nrtelfuncionario);
        $nrtelfuncionario = str_replace(' ', '', $nrtelfuncionario);
        /* ------------------------------- Adicionando na tabela de Funcionários ------------------------------- */
            $nrfuncionario = $this->newCode->getCodeByTableName('FCM_FUNCIONARIO', 20, 1, 10, true); //('tabela, nrorg, ...')

            $userInfos = array(
                'NRFUNCIONARIO' => $nrfuncionario,
                'NMFUNCIONARIO' => $nmfuncionario,
                'NRPESSOA' => null,
                'CDOPERADOR' => $cdoperador,
                'NRRGFUNCIONARIO' => $nrrgfuncionario,
                'NRCPFFUNCIONARIO' => $nrcpffuncionario,
                'DSEMAILFUNCIONARIO' => $dsemailfuncionario,
                'HRENTRADAPADR' => null,
                'HRSAIDAPADR' => null,
                'IDATIVO' => 'S',
                'IDTURNOFUNCIONARIO' => null,
                'NRTELFUNCIONARIO'   => $nrtelfuncionario,
            );
           $this->UsuariosFactory->createUserFactory($userInfos);

        /* ------------------------------- Adicionando na tabela de relação funcionário-função ------------------------------- */

            $relacfuncperfacess = $this->newCode->getCodeByTableName('FCM_RELACFUNCPERFACESS', 20, 1, 10, true);

            $relacPosInfos = array(
                'RELACFUNCPERFACESS' => $relacfuncperfacess,
                'NRPERFILACESSO' => $nrperfilacesso,
                'NRFUNCIONARIO' => $nrfuncionario,
                'IDATIVO' => 'S'
            );
            $this->UsuariosFactory->createRelacPosFactory($relacPosInfos);

        /* ------------------------------- adicionando na tabela de relação funcionário-setor ------------------------------- */


            if ($nrsetor !== null) {
                $nrrelacfuncsetor = $this->newCode->getCodeByTableName('FCM_RELACFUNCSETOR', 20, 1, 10, true);
                $relacSectorInfos = array(
                    'NRRELACFUNCSETOR' => $nrrelacfuncsetor,
                    'NRSETOR' => $nrsetor,
                    'NRFUNCIONARIO' => $nrfuncionario,
                    'IDATIVO' => 'S'
                );
                $this->UsuariosFactory->createRelacSectorFactory($relacSectorInfos);
            }

            $this->connection->commit();
            $response = 'Inserido com sucesso';
        } catch(\Exception $e) {
            $this->connection->rollback();
            $response = $e->getMessage();
        }
        return $response;
    }

    public function getUserInfosService($nrfuncionario){
        $params = array(
            'NRFUNCIONARIO' => $nrfuncionario
        );
        $operadores = $this->UsuariosFactory->getUserInfosFactory($params);
        return $operadores;
    }

    public function updateUserService($nrfuncionario, $nmfuncionario, $nrperfilacesso, $nrcpffuncionario, $nrrgfuncionario, $dsemailfuncionario, $nrtelfuncionario, $nrsetor, $relacfuncperfacess, $nrrelacfuncsetor, $cdoperador) {

        $nrrgfuncionario = str_replace('.', '', $nrrgfuncionario);
        $nrcpffuncionario = str_replace('.', '', $nrcpffuncionario);
        $nrcpffuncionario = str_replace('-', '', $nrcpffuncionario);
        $nrtelfuncionario = str_replace('(', '', $nrtelfuncionario);
        $nrtelfuncionario = str_replace(')', '', $nrtelfuncionario);
        $nrtelfuncionario = str_replace('-', '', $nrtelfuncionario);
        $nrtelfuncionario = str_replace(' ', '', $nrtelfuncionario);

        $validParam = array(
            'NRFUNCIONARIO' => $nrfuncionario
        );


        $this->connection->beginTransaction();
        try{

            $userInfos = array(
                    'NRFUNCIONARIO' => $nrfuncionario,
                    'NMFUNCIONARIO' => $nmfuncionario,
                    'NRRGFUNCIONARIO' => $nrrgfuncionario,
                    'NRCPFFUNCIONARIO' => $nrcpffuncionario,
                    'DSEMAILFUNCIONARIO' => $dsemailfuncionario,
                    'NRTELFUNCIONARIO'   => $nrtelfuncionario,
                    'CDOPERADOR' => $cdoperador
                );
            $this->UsuariosFactory->updateUserFactory($userInfos);

            /* ------ Editando na tabela de relação funcionário-função ------ */
            $relacPosInfos = array(
                'RELACFUNCPERFACESS' => $relacfuncperfacess,
                'NRPERFILACESSO' => $nrperfilacesso,
                'NRFUNCIONARIO' => $nrfuncionario
            );

            $this->UsuariosFactory->updateRelacPosFactory($relacPosInfos);

            /* ------ Editando na tabela de relação funcionário-setor ------ */

            if ($nrrelacfuncsetor == null) {
                $nrrelacfuncsetor = $this->newCode->getCodeByTableName('FCM_RELACFUNCSETOR', 20, 1, 10, true);

                $relacSectorInfos = array(
                    'NRRELACFUNCSETOR' => $nrrelacfuncsetor,
                    'NRSETOR' => $nrsetor,
                    'NRFUNCIONARIO' => $nrfuncionario,
                    'IDATIVO' => 'S'
                );
                $this->UsuariosFactory->createRelacSectorFactory($relacSectorInfos);
                
            } else {
                $relacSectorInfos = array(
                    'NRRELACFUNCSETOR' => $nrrelacfuncsetor,
                    'NRSETOR' => $nrsetor,
                    'NRFUNCIONARIO' => $nrfuncionario
                );
                $this->UsuariosFactory->updateRelacSectorFactory($relacSectorInfos);
            }


            $this->connection->commit();
            $response = 'Editado com sucesso';
        } catch(\Exception $e) {
            $this->connection->rollback();
            $response = $e->getMessage();
        }
        return $response;
    }

    public function deleteUsersService($params){
        $dados = array(
            "count" => 0,
            "naoInseridos" => []
        );
        $cont = 0;
        
        foreach($params as $userX) {
            foreach($userX as $user){
                $validParm = array (
                    'NRFUNCIONARIO' => $user
                );
                $operadores = $this->UsuariosFactory->validUsersFactory($validParm);
                $valida = $operadores[0]['VALIDA'];
                
                if($valida == 0){
                    $validaSetor = $this->UsuariosFactory->validSectorUsersFactory($validParm);
                    $valida = $validaSetor[0]['VALIDA'];
                    if($valida ==0){
                        // $this->UsuariosFactory->deleteUsersFactory($validParm);
                        $this->UsuariosFactory->inativarUser($validParm);
                    } else {
                     $dados["count"] = $dados["count"] + 1;
                     $dados["naoInseridos"][] = $user;
                    }
                } else {
                    $dados["count"] = $dados["count"] + 1;
                    $dados["naoInseridos"][] = $user;
                }
            }
        }
        return $dados;
    }

    public function getOperadorService(){
        return $this->UsuariosFactory->getOperadorFactory();
    }


}
?>